#this file calculates the total moeny earned using the different betting strategies for the constant models 
#it does not use functions but rather a for loop
s = 12
FixedBet_pois = rep(0,s)
FixedRet_pois = rep(0,s)
Rue_pois = rep(0,s)
Kelly_pois = rep(0,s)

FixedBet_GP = rep(0,s)
FixedRet_GP = rep(0,s)
Rue_GP = rep(0,s)
Kelly_GP = rep(0,s)

FixedBet_multi = rep(0,s)
FixedRet_multi = rep(0,s)
Rue_multi = rep(0,s)
Kelly_multi = rep(0,s)

FixedBet_HL = rep(0,s)
FixedRet_HL = rep(0,s)
Rue_HL = rep(0,s)
Kelly_HL = rep(0,s)


seasons = c("0910","1011","1112","1213","1314","1415","1516","1617","1718","1819","1920","2021")
Pois = T
GP = T
HL = T
Multi = T
temp=Sys.time()
temp1=Sys.time()
#choose which seasons to estimate by picking differnt values for j.
for( j in 1:12){
  print(Sys.time()-temp1)
  temp1=Sys.time()
  print(Sys.time()-temp)
  print(j)
  season=seasons[j]
  PL=eval(as.symbol(paste0("pl_",season)))
  odds= cbind(PL$B365H,PL$B365D,PL$B365A)[191:380,]
  results = PL$FTR[191:380]
  if(Pois){
    probs_Pois = timePoisBIToProbs(PL,19)
    FixedBet_pois[j]=fixedBet(probs_Pois,odds,1,results)[20]/19*100
    FixedRet_pois[j] = FixedReturn(probs_Pois,odds,1,results)[20]/19*100
    Rue_pois[j] = RueVariance(probs_Pois,odds,1,results)[20]/19*100
    Kelly_pois[j]=(testKelly(probs_Pois,odds,1000,results,0.2)[191]-1000)/1000*100
  }
  if(GP){
    probs_GP = timeGPtoProbs(PL,19)
    FixedBet_GP[j]=fixedBet(probs_GP,odds,1,results)[20]/19*100
    FixedRet_GP[j] = FixedReturn(probs_GP,odds,1,results)[20]/19*100
    Rue_GP[j] = RueVariance(probs_GP,odds,1,results)[20]/19*100
    Kelly_GP[j]=(testKelly(probs_GP,odds,1000,results,0.2)[191]-1000)/1000*100
  }
  if(HL){
    probs_HL = HLCtoProbs(PL,19)
    FixedBet_HL[j]=fixedBet(probs_HL,odds,1,results)[20]/19*100
    FixedRet_HL[j] = FixedReturn(probs_HL,odds,1,results)[20]/19*100
    Rue_HL[j] = RueVariance(probs_HL,odds,1,results)[20]/19*100
    Kelly_HL[j]=(testKelly(probs_HL,odds,1000,results,0.2)[191]-1000)/1000*100
  }
  if(Multi){
    probs_multi = multinomToProbs(PL,19)
    FixedBet_multi[j]=fixedBet(probs_multi,odds,1,results)[20]/19*100
    FixedRet_multi[j] = FixedReturn(probs_multi,odds,1,results)[20]/19*100
    Rue_multi[j] = RueVariance(probs_multi,odds,1,results)[20]/19*100
    Kelly_multi[j]=(testKelly(probs_multi,odds,1000,results,0.2)[191]-1000)/1000*100
  }
  

}
#poisson glmm
sum(FixedBet_pois[2:12])/11
sum(FixedRet_pois[2:12])/11
sum(Rue_pois[2:12])/11
sum(Kelly_pois[2:12])/11

sum(FixedBet_pois)/12
sum(FixedRet_pois)/12
sum(Rue_pois)/12
sum(Kelly_pois)/12

#generalized poisson
sum(FixedBet_GP[2:12])/11
sum(FixedRet_GP[2:12])/11
sum(Rue_GP[2:12])/11
sum(Kelly_GP[2:12])/11

sum(FixedBet_GP)/12
sum(FixedRet_GP)/12
sum(Rue_GP)/12
sum(Kelly_GP)/12

#multinomial glmm

sum(FixedBet_multi[2:12])/11
sum(FixedRet_multi[2:12])/11
sum(Rue_multi[2:12])/11
sum(Kelly_multi[2:12])/11

sum(FixedBet_multi)/12
sum(FixedRet_multi)/12
sum(Rue_multi)/12
sum(Kelly_multi)/12

#Data intensive

sum(FixedBet_HL[2:12])/11
sum(FixedRet_HL[2:12])/11
sum(Rue_HL[2:12])/11
sum(Kelly_HL[2:12])/11

sum(FixedBet_HL)/12
sum(FixedRet_HL)/12
sum(Rue_HL)/12
sum(Kelly_HL)/12

